public class Orc extends Entity {
    public static final char ORC = 'O'; // orc are represented as an O on the grid
    public static final int ORC_DAMAGE = 3; // damage
    public static final int ORC_HP = 10; // health for each

    // is a subclass of entity passing in appearance, health, and damage
    public Orc() {
        super(ORC, ORC_HP, ORC_DAMAGE);
    }

    // both are the debug statements for attack and loss conditions
    @Override
    public void debugAttack(GameStatus status, int tempRow, int tempColumn, int targetRow, int targetColumn, int HP, int HPAfter) {
        status.orcAttackDebug(tempRow, tempColumn, targetRow, targetColumn, HP, HPAfter);
    }

    @Override
    public void debugLossConditions(GameStatus status, int entityCounter){
        status.orcLoseDebug(entityCounter);
    }

    @Override
    public void debugMovement(GameStatus status, int oldRow, int oldCol, int newRow, int newCol){
        status.orcMoveDebug(oldRow,oldCol,newRow,newCol);
    }
}