//Author Ethan McCorquodale

public class World
{
    public static final int SIZE = 10; //size of world
    private int locationIndex = 0; //creates a local index for the location array in the Display method. // changed from i since that's not a great name
    Location[] location = new Location[100];//an array that'll track each entities type,location coordinates and if it can move.
    int tempRow = 0; // temp row and colum for switching and swapping things in the world
    int tempColumn = 0;
    int oldRow; // old row and colum for switching and swapping things in the world
    int oldCol;
    int turnSinceAtk; // to help with deciding if a cease fire occurred resets every attack
    public Entity [][] aWorld; // world of entities Elf, Orcs or null
    public boolean programRunning = true; //programming running
    
    GameStatus status = new GameStatus();
    // Post-condition: the position of the characters in the
    // starting input file will determine the position of the
    // objects in the array. The type of character in the file
    // determines the appearance of the Entity(O or D) or if the
    // element is empty (spaces become null elements)

	// constructor initialize the grid and the entities location
	public World()
	{
		aWorld = new Entity[SIZE][SIZE]; // world of the size 10
		aWorld = FileInitialization.read(); // get info from the provided txt file
		initializeGrid();
	}

	// print borders and initialize locations
	public void initializeGrid(){
		for (int row = 0; row < SIZE; row++){ // changed all instances of r and c so its more readable
			System.out.println("\n - "+"- "+"- "+"- "+"- "+"- "+"- "+"- "+"- "+ "- "); // removed unnecessary print
			for (int column = 0; column < SIZE; column++){
				initializeLocations(row, column);
			}
			System.out.print("|");
		}
		System.out.println("\n - "+"- "+"- "+"- "+"- "+"- "+"- "+"- "+"- "+ "- ");
		sortLocations();
	}

	// place the Orcs, Elves or nulls entities in the world
	public void initializeLocations(int row, int column){
		if (aWorld[row][column] == null) {
			System.out.print("| ");
			return; // no entity so move on
		}
		char currentCellAppearance = aWorld[row][column].getAppearance();
		System.out.print("|"+currentCellAppearance);
		location[locationIndex] = new Location(row,column,currentCellAppearance);//Initializes each Entities location/type
		if (location[locationIndex].getType() == 'O') {//this checks the type and counts +1 if it's an orc
			Entity.incrementOrcCounter(1); // increase the count of orcs
		}
		if (location[locationIndex].getType() == 'E') {
			Entity.incrementElfCounter(1); // same with elves
		}
		locationIndex++;//Cause each initialization of the location[locationIndex] to go to the next element
	}

	//supposed to try and sort null elements and bring them to the end doesn't always work as intended
	public void sortDead() {
		for (int locationIndex = 0; locationIndex<=Entity.getElfCounter()+Entity.getOrcCounter();locationIndex++) {
			if (location[locationIndex] == null) {
				continue; // its null then move on
			}
			if((aWorld[location[locationIndex].getRow()][location[locationIndex].getColumn()] != null)||(location[locationIndex+1] == null)) {
				continue; // if the element in the world isn't null then move on or next index in location is null
			}
			// swap the values in the array
			location[locationIndex] = location[locationIndex+1];
			location[locationIndex+1] = null;
			if(locationIndex-2 >= 0 && location[locationIndex-2]== null) {
				sortDead();
			}
		}
	}

	//puts the elfs in the beginning of the array,
	// checks if there is an orc before and elf and if there is it swaps positions in the array
	// basically moves all the entities (orc or elves) to the front of the array since we don't care about null entities
	public void sortLocations() {
		int orcCounter = Entity.getOrcCounter();
		for (int j = 0; j<Entity.getElfCounter()+orcCounter; j++) {
			if (location[j+orcCounter] == null){
				continue; // if its null then move on
			}
			if(((location[j].getType() != 'O')||(location[j+orcCounter].getType() != 'E'))) {
				continue; // if it's not an elf or orc move on
			}
			// get row, columns and entity type (char of O or E)
			// and set the new values
			tempRow = location[j+orcCounter].getRow();
			tempColumn = location[j+orcCounter].getColumn();
			char tempType = location[j+orcCounter].getType();
			location[j+orcCounter].setType(location[j].getType());
			location[j+orcCounter].setColumn(location[j].getColumn());
			location[j+orcCounter].setRow(location[j].getRow());
			location[j].setRow(tempRow);
			location[j].setColumn(tempColumn);
			location[j].setType(tempType);
		}
	}
	// handles attacking
	public void attack(int index) {// new
		if(aWorld[tempRow][tempColumn] == null){
			return; // if null move on
		}
		if((location[index].getType() == 'O') && (aWorld[tempRow][tempColumn].getAppearance() == 'O')) {
			return; // if attacking their own kind move on (won't attack)
		}
		if((location[index].getType() == 'E') && (aWorld[tempRow][tempColumn].getAppearance() == 'E')) {
			return; // if attacking their own kind move on (won't attack)
		}
		turnSinceAtk = 0; // reset since we are now attacking
		if((location[index].getType() == 'E')&&(aWorld[location[index].getRow()][location[index].getColumn()] != null)) {
			Entity attackingEntity = new Elf(); //initialize elf which is a subclass of entity and call attack logic
			attackLogic(attackingEntity, index); // with elf as the attacking entity
		} else if((location[index].getType() == 'O')&&(aWorld[location[index].getRow()][location[index].getColumn()] != null)) {
			Entity attackingEntity = new Orc(); // exact same idea just with orc
			attackLogic(attackingEntity, index);
		} else {
			location[index].setCanMove(true); // they can move if they aren't attacking
		}
	}

	// logic for attacking gets health and subtracts the attacking entities damage and sets the new health
	public void attackLogic(Entity attackingEntity, int index){
		int entityDmg = attackingEntity.getDamage();
		int HP = aWorld[tempRow][tempColumn].getHitPoints();
		aWorld[tempRow][tempColumn].setHitPoints(aWorld[tempRow][tempColumn].getHitPoints()-entityDmg);
		int HPAfter = aWorld[tempRow][tempColumn].getHitPoints();

		if (GameStatus.debugModeOn) {//debug attack data for elf attackers, apart of elf subclass
			attackingEntity.debugAttack(status, tempRow, tempColumn, location[index].getRow(), location[index].getColumn(),HP,HPAfter);
		}
		deathLogic(attackingEntity, index); // check if attacker killed enemy
		victoryLogic(attackingEntity); // check if no enemy remains
		if(GameStatus.debugModeOn) {//debug lose condition data, part of subclasses
			if (attackingEntity instanceof Elf) {
				attackingEntity.debugLossConditions(status, Entity.getOrcCounter());
			} else if (attackingEntity instanceof Orc) {
				attackingEntity.debugLossConditions(status, Entity.getElfCounter());
			}
		}
	}

	// if the enemy lost all its health it is killed and the count of that entity goes down
	public void deathLogic(Entity attackingEntity, int index){
		if (aWorld[tempRow][tempColumn].getHitPoints() >0){
			return; // if they are still alive then move on this doesn't apply
		}
		aWorld[tempRow][tempColumn] = null;

		if (attackingEntity instanceof Elf) {
			Entity.incrementOrcCounter(-1); // increment by a negative value
		} else if (attackingEntity instanceof Orc) {
			Entity.incrementElfCounter(-1);
		}
		sortDead();
		if(location[index] != null) {
			location[index].setCanMove(true);
		}
	}

	// if there is no more enemies than the attackers have won so print out who won and end the game
	public void victoryLogic(Entity attackingEntity){
		if (attackingEntity instanceof Elf && Entity.getOrcCounter() > 0) {
			return; // if there still exists orcs and elves are attacking then no victory
		}
		else if (attackingEntity instanceof Orc && Entity.getElfCounter() > 0) {
			return; // same exact thing but opposite
		}
		// get the name of the attacking entity since they won
		System.out.println(attackingEntity.getClass().getSimpleName() + " wins, no more opponents left.");
		programRunning = false; //end game
	}

	// check perimeter of the index
	public boolean checkPerimeter(int index) {//looks at all the spaces around the current index of location[index] looking for things not null
		if (location[index] == null){
			return false; // if null move on
		}
		for(int row = location[index].getRow()-1; row<location[index].getRow()+2;row++) {
			for(int column = location[index].getColumn()-1; column<location[index].getColumn()+2;column++ ) {
				if((row > 9)||(column > 9)||(row <= - 1)||(column <= -1)){ //ensuring row/column is in aWorld
					continue; // if outside world then move on
				}
				if((aWorld[row][column] == null) || (location[index].getType() == aWorld[row][column].getAppearance())) {
					continue; // if null move on or if they are next to their kind then move on
				}
				// if we are here then their is an enemy so stop and prepare to attack
				location[index].setCanMove(false);
				tempRow = row; // set temp row and column
				tempColumn = column;
				attack(index); // attack with the current index as the attacking entity
				return true; // return true there is an enemy
			}
		}
		location[index].setCanMove(true); // no enemy so can move
		return false; // no enemy
	}
	// move the current entity
	//changes the value of aWorld[][] must set old position to null then update it to the new position.
	public void move(int index) {
		if (checkPerimeter(index)){
			return; // check the around current index if there is an enemy dont move
		}
		if (location[index] == null) {
			return; // move on if it's not an entity at index
		}
		if (!location[index].getCanMove()){
			return; // if it already can't move, move on
		}

		if((location[index].getRow()-1 != -1)&&(location[index].getColumn()-1 != -1)) {
			moveLogic('E', index, -1); // logic behind moving
		}
		if((location[index].getRow()+1 != 10)&&(location[index].getColumn()+1 != 10)) {
			moveLogic('O', index, 1);
		}
		if ((GameStatus.debugModeOn)&&(location[index] != null)) {
			if (location[index].getType() == 'E') {//elf move data
				Entity movingEntity = new Elf();
				movingEntity.debugMovement(status, oldRow,oldCol,location[index].getRow(),location[index].getRow());
			} else if (location[index].getType() == 'O') {//orc move data
				Entity movingEntity = new Orc();
				movingEntity.debugMovement(status, oldRow,oldCol,location[index].getRow(),location[index].getRow());
			}
		}
	}

	// increment the rows and columns setting the entity at the new location and removing the old one
	// orcs move down and elves move up, so -1 for elves and +1 for orcs (for increment)
	public void moveLogic(char entityType, int index, int increment){
		if ((location[index].getType() == entityType)&&(aWorld[location[index].getRow()+ increment][location[index].getColumn()+increment]== null)) {
			oldRow = location[index].getRow();
			oldCol = location[index].getColumn();
			location[index].setRow(oldRow+increment);
			location[index].setColumn(oldCol+increment);
			aWorld[oldRow+increment][oldCol+increment] = aWorld[oldRow][oldCol];
			aWorld[oldRow][oldCol] = null;
		}
	}
}